<template>
  <v-timeline
    align="center"
    side="start"
    hide-opposite
    :line-thickness="lineThickness"
    :line-inset="lineInset"
    class="!h-[376px] left-0"
  >
    <template #default>
      <!-- Handle empty state -->
      <template v-if="isItemsEmpty">
        <div class="flex justify-center items-center h-full text-gray-500">
          No timeline items available.
        </div>
      </template>

      <!-- Render timeline items -->
      <template v-else>
        <v-timeline-item
          v-for="(item, index) in items"
          :key="index"
          :dot-color="getDotColor(index)"
          :icon="item.icon"
          :size="size"
          @click="emit('change-timeline', index)"
        >
          <template #default>
            <div class="flex items-center gap-2 cursor-pointer">
              <svn-pro-text
                body-medium
                :bold="isCurrentStep(index)"
                :regular="!isCurrentStep(index)"
                :color="titleColor(index)"
              >
              {{ item?.title ?? "Untitled" }}
            </svn-pro-text>
            </div>
          </template>
        </v-timeline-item>
      </template>
    </template>
  </v-timeline>
</template>

<script setup>
import { SizeEnum } from '@/constants/types.js';
import SvnProText from "@/components/styles/SvnProText.vue";
import { computed } from "vue";

const props = defineProps({
  items: {
    type: Array,
    default: () => [],
    validator: (value) => Array.isArray(value) && value.every(item => typeof item === 'object')
  },
  lineThickness: {
    type: Number,
    default: 1,
    validator: (value) => Number.isFinite(value) && value >= 0
  },
  lineInset: {
    type: Number,
    default: 1,
    validator: (value) => Number.isFinite(value) && value >= 0
  },
  currentStepIndex: {
    type: Number,
    default: 1,
    validator: (value) => Number.isInteger(value) && value >= 0
  },
  lastStepIndex: {
    type: Number,
    default: 3,
    validator: (value) => Number.isInteger(value) && value >= 0
  },
  size: {
    type: String,
    default: SizeEnum.SMALL,
    validator: (value) => Object.values(SizeEnum).includes(value)
  }
});

const emit = defineEmits(["change-timeline"]);

const isCurrentStep = (index) => {
  return index === props.currentStepIndex
}

const isItemsEmpty = computed(() => {
  return props.items.length <= 0
})

const titleColor = (index) => {
  return isCurrentStep(index) ? 'primary' : 'onSurface'
}

const getDotColor = (index) => {
  const isLastStep = index === props.items.length - 1;
  const isCompletedStep = index <= props.lastStepIndex;

  if (isCurrentStep(index) && isLastStep) return "primary";
  if (isCompletedStep && !isLastStep) return "primary";
  return "surfaceLight";
};

</script>
